<script setup >

const props = defineProps ({
    data: {

      required: true
    }

});
const emit = defineEmits(['email_post']);

const class_warning = getClassWarning ();

const signalerMail= ref ("");
const inputSignalerMailClass = ref ("");

const signalerMotif= ref ("");
const inputSignalerMotifClass = ref ("");

const signalerDescription= ref ("");
const inputSignalerDescriptionClass= ref ("");

const hadDisplayWarning=ref(false);

function evaluateWarning () {
        if (checkInput_signaler_adresse_ok ()) {
            inputSignalerMailClass.value="";
        }else if (hadDisplayWarning.value){
            inputSignalerMailClass.value=class_warning;
        }

        if (checkInput_signaler_motif_ok ()) {
            inputSignalerMotifClass.value="";
        }else if (hadDisplayWarning.value){
            inputSignalerMotifClass.value=class_warning;
        }

        if (checkInput_signaler_description_ok ()) {
            inputSignalerDescriptionClass.value="";       
        }else if (hadDisplayWarning.value){
            inputSignalerDescriptionClass.value=class_warning;
        }
}

function checkRequiredData () {
    return checkInput_signaler_adresse_ok () && checkInput_signaler_motif_ok () && checkInput_signaler_description_ok ();
}

function checkInput_signaler_adresse_ok (){
    return isAdresseMailValide (signalerMail.value);
}

function checkInput_signaler_motif_ok (){
    return signalerMotif.value!=null && signalerMotif.value!=="";
}

function checkInput_signaler_description_ok (){
    return signalerDescription.value!=null && signalerDescription.value!=="";
}

function signalerEvent () {
    hadDisplayWarning.value=true;

    if (checkRequiredData ()) {
        sendEmail1Process();
    }else {
        evaluateWarning ();
    }
}

async function sendEmail1Process() {
  const mail = useMail();

    const contenuMail= 
        "auteur: "+signalerMail.value+
        "\nevent: "+(props.data.name?props.data.name:props.data.event.name)+
        "\nmotif: "+signalerMotif.value+
        "\ndescription: "+signalerDescription.value
    ;

    try {
/*            
        console.log (            
            "ENVOIE DE MAIL: "+
            "\nto: "+useRuntimeConfig().public.mailFrom+
            "\nfrom: "+useRuntimeConfig().public.mailFrom+
            "\nsubject: "+ "SIGNALER: "+(props.data.name?props.data.name:props.data.event.name)+
            "\ntext: "+contenuMail);
*/

        await mail.send({
            to: useRuntimeConfig().public.mailFrom,
            from: useRuntimeConfig().public.mailFrom,
            subject: "SIGNALER: "+(props.data.name?props.data.name:props.data.event.name),
            text: contenuMail,
        });

        emit("email_post");

    } catch (e) {
        alert ("problème lors de l'envoie de l'email");
        console.log (e);
    }
}
</script>

<template >
    <div class="flex flex-col gap-y-4 w-full bg-white">
        <div class="flex flex-row justify-center">
            <img src="/images/exclamation.svg" class="m-1 pb-2" width="22px" height="22px" alt="signaler" />
            <h1 class="text-3xl font-bold font-las">Signaler</h1>
        </div>

        <div class="flex flex-row justify-center">
            <h2 class="max-h-9 overflow-hidden text-2xl font-las">{{ props.data?(props.data.name?props.data.name:props.data.event.name):'' }}</h2>
            <img class="mb-4" src="/images/quotes.svg" width="22px" height="22px">
        </div>

        <div class="max-h-20 overflow-hidden flex flex-row justify-center">
            <h3 class=" font-las">{{  props.data!=null?((props.data.name!=null)?props.data.event.name:""):"" }}</h3>
        </div>
    
        <FormInput
            :id="'input_signaler_mail'"
            @value="(value) => (signalerMail = value)"
            :value="signalerMail"
            :text="'Ton adresse mail'"
            :maxlength="'256'"
            :extend_class="inputSignalerMailClass"
            @blur="evaluateWarning"
            class="md:ml-16 md:mr-16"
        />

        <FormInput
            :id="'input_signaler_motif'"
            @value="(value) => (signalerMotif = value)"
            :value="signalerMotif"
            :text="'Motif du signalement'"
            :maxlength="'256'"
            :extend_class="inputSignalerMotifClass"
            @blur="evaluateWarning"
            class="md:ml-16 md:mr-16"
        />

        <FormInput
            :type="'textarea'"
            :id="'input_signaler_description'"
            @value="(value) => (signalerDescription = value)"
            :value="signalerDescription"
            :text="'Description'"
            :maxlength="'1024'"
            :details="'h-[100px]'"
            :extend_class="inputSignalerDescriptionClass"
            @blur="evaluateWarning"
            class="md:ml-16 md:mr-16"
        />

        <ButtonAction
            :id="'button_post_signaler_id'"
            :action-click="signalerEvent"
            :action-text="'SIGNALER'"
            class="mb-4"
        />
    </div>
</template>
